

#include <PID_v2.h> // PID Regler aus einer Bibliothek

#define PIN_INPUT 0  // Festlegung des Eingangs für die Regelgröße x
#define PIN_OUTPUT 9 // Festlegung des Ausgangs für die Stellgröße y

// Festlegung der Reglerparameter
double Kp = 1, Ki = 1, Kd = 3;
PID_v2 myPID(Kp, Ki, Kd, PID::Direct);

void setup() {
  Serial.begin(9600);   // Öffnung der seriellen Schnittstelle
  myPID.Start(analogRead(PIN_INPUT),  // Start des Reglers : Einlesen der Regelgröße x
              0,                      // Anfangswert für die Stellgröße y
              100);                   // Führungsgröße w = 100
}

void loop() {
  const double input = analogRead(PIN_INPUT); // Eingabe der Regelgröße x in den Regelalgorithmus
  const double output = myPID.Run(input);     // Berechnung der Stellgröße
  analogWrite(PIN_OUTPUT, output);            // Ausgabe der Stellgröße y auf Kanal 9 (PWM Ausgang)
  Serial.print("Regelgröße x:");// Angabe der Regelgrösse auf dem Monitor
  Serial.println(input); // Regelgröße x
  Serial.print ("Führungsgröße w:"); // Angabe der Führungsgröße auf dem Monitor
  Serial.println(100);  // Führungsgröße w
}
